Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj	(revision 14875)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj	(revision 14897)
@@ -129,4 +129,5 @@
     <Compile Include="Push\Data\Tree\TreeExtensions.cs" />
     <Compile Include="Push\Data\Tree\TreeNode.cs" />
+    <Compile Include="Push\Constants\Environment.cs" />
     <Compile Include="Push\Exporter\Exporter.cs" />
     <Compile Include="Push\Expressions\BooleanExpressions.cs" />
@@ -149,4 +150,5 @@
     <Compile Include="Push\Expressions\NameExpressions.cs" />
     <Compile Include="Push\Expressions\PopExpressions.cs" />
+    <Compile Include="Push\Expressions\PrintExpressions.cs" />
     <Compile Include="Push\Expressions\PushExpressions.cs" />
     <Compile Include="Push\Expressions\PushProgram.cs" />
@@ -188,5 +190,4 @@
     <Compile Include="Push\Generators\CodeGenerator\RecursiveCodeGenerator.cs" />
     <Compile Include="Push\Generators\ErcUtils.cs" />
-    <Compile Include="Push\Generators\StringGenerator.cs" />
     <Compile Include="Push\Interpreter\Extensions.cs" />
     <Compile Include="Push\Interpreter\IInternalPushInterpreter.cs" />
@@ -199,8 +200,11 @@
     <Compile Include="Push\Interpreter\PushInterpreterPool.cs" />
     <Compile Include="Push\Parser\PushParser.cs" />
+    <Compile Include="Push\Problem\BenchmarkSuite\PushBenchmarkSuiteSolution.cs" />
     <Compile Include="Push\Problem\DataBounds.cs" />
     <Compile Include="Push\Problem\EvaluationResult.cs" />
     <Compile Include="Push\Problem\IndividualMapper.cs" />
-    <Compile Include="Push\Problem\PushEvaluator.cs" />
+    <Compile Include="Push\Problem\BenchmarkSuite\PushBenchmarkSuiteEvaluator.cs" />
+    <Compile Include="Push\Problem\BenchmarkSuite\PushBenchmarkSuiteProblem.cs" />
+    <Compile Include="Push\Problem\IPushEvaluator.cs" />
     <Compile Include="Push\Problem\PushProblem.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
@@ -220,9 +224,15 @@
       <DependentUpon>ExpressionSelectionView.cs</DependentUpon>
     </Compile>
-    <Compile Include="Push\Views\PushProgramDebuggerView.cs">
+    <Compile Include="Push\Views\PushDebuggerView.cs">
       <SubType>UserControl</SubType>
     </Compile>
-    <Compile Include="Push\Views\PushProgramDebuggerView.Designer.cs">
-      <DependentUpon>PushProgramDebuggerView.cs</DependentUpon>
+    <Compile Include="Push\Views\PushDebuggerView.Designer.cs">
+      <DependentUpon>PushDebuggerView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Push\Problem\BenchmarkSuite\BenchmarkSuitePushSolutionView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Push\Problem\BenchmarkSuite\BenchmarkSuitePushSolutionView.Designer.cs">
+      <DependentUpon>BenchmarkSuitePushSolutionView.cs</DependentUpon>
     </Compile>
   </ItemGroup>
@@ -231,10 +241,14 @@
       <Generator>ResXFileCodeGenerator</Generator>
       <LastGenOutput>Resources.Designer.cs</LastGenOutput>
+      <SubType>Designer</SubType>
     </EmbeddedResource>
     <EmbeddedResource Include="Push\Views\ExpressionSelectionView.resx">
       <DependentUpon>ExpressionSelectionView.cs</DependentUpon>
     </EmbeddedResource>
-    <EmbeddedResource Include="Push\Views\PushProgramDebuggerView.resx">
-      <DependentUpon>PushProgramDebuggerView.cs</DependentUpon>
+    <EmbeddedResource Include="Push\Views\PushDebuggerView.resx">
+      <DependentUpon>PushDebuggerView.cs</DependentUpon>
+    </EmbeddedResource>
+    <EmbeddedResource Include="Push\Problem\BenchmarkSuite\BenchmarkSuitePushSolutionView.resx">
+      <DependentUpon>BenchmarkSuitePushSolutionView.cs</DependentUpon>
     </EmbeddedResource>
   </ItemGroup>
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Plugin.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Plugin.cs	(revision 14875)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Plugin.cs	(revision 14897)
@@ -29,4 +29,5 @@
   [PluginFile("HeuristicLab.Problems.ProgramSynthesis.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Problems.ProgramSynthesis.BenchmarkSuite", "1.0")]
+  [PluginDependency("HeuristicLab.Problems.ProgramSynthesis.Base", "1.0")]
   [PluginDependency("HeuristicLab.Collections", "3.3")]
   [PluginDependency("HeuristicLab.Common", "3.3")]
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/IReadonlyPushConfiguration.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/IReadonlyPushConfiguration.cs	(revision 14875)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/IReadonlyPushConfiguration.cs	(revision 14897)
@@ -1,8 +1,7 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Configuration {
   using System.Collections.Generic;
-
-  using HeuristicLab.Common;
-  using HeuristicLab.Problems.ProgramSynthesis.Base.Erc.Interfaces;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
+  using Base.Erc;
+  using Common;
+  using Stack;
 
   public interface IReadOnlyPushConfiguration : IDeepCloneable {
@@ -12,4 +11,5 @@
     int MaxStringLength { get; }
     int MaxVectorLength { get; }
+    int MinPointsInProgram { get; }
     int MaxPointsInProgram { get; }
     int MaxPointsInRandomExpression { get; }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfiguration.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfiguration.cs	(revision 14875)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfiguration.cs	(revision 14897)
@@ -5,5 +5,4 @@
   using Attributes;
   using Base.Erc;
-  using Base.Erc.Interfaces;
   using Common;
   using Core;
@@ -14,7 +13,4 @@
   [StorableClass]
   public class PushConfiguration : ParameterizedNamedItem, IReadOnlyPushConfiguration, IEnabledExpressionsConfiguration {
-
-
-
     public PushConfiguration() {
       Name = "Push Configuration";
@@ -25,9 +21,10 @@
       ErcOptions = new ErcOptions();
       EvalPushLimit = 1024;
-      MaxPointsInProgram = 128;
+      MinPointsInProgram = 25;
+      MaxPointsInProgram = 200;
       TopLevelPushCode = true;
       TopLevelPopCode = false;
       MaxPointsInRandomExpression = 64;
-      MaxStringLength = 32;
+      MaxStringLength = 128;
       MaxVectorLength = 64;
       MaxDepth = 32;
@@ -38,5 +35,5 @@
     private void InitEnabledStacks(bool state = true) {
       foreach (StackTypes type in Enum.GetValues(typeof(StackTypes))) {
-        if (!enabledStacks.ContainsKey(type))
+        if (!enabledStacks.ContainsKey(type) && type != StackTypes.None)
           enabledStacks.Add(type, state);
       }
@@ -54,4 +51,5 @@
       ErcOptions = cloner.Clone(origin.ErcOptions);
       EvalPushLimit = origin.EvalPushLimit;
+      MinPointsInProgram = origin.MinPointsInProgram;
       MaxPointsInProgram = origin.MaxPointsInProgram;
       MaxPointsInRandomExpression = origin.MaxPointsInRandomExpression;
@@ -72,5 +70,5 @@
 
     [Storable]
-    private Dictionary<StackTypes, bool> enabledStacks;
+    private readonly Dictionary<StackTypes, bool> enabledStacks;
 
     public IReadOnlyDictionary<StackTypes, bool> EnabledStacks { get { return enabledStacks; } }
@@ -122,8 +120,16 @@
 
     /// <summary>
+    ///     This is the minimum size of an item on the CODE stack, expressed as a number of points.
+    ///     A point is an instruction, a literal, or a pair of parentheses. Any instruction that would cause this limit to be
+    ///     exceeded should instead act as a NOOP, leaving all stacks in the states that they were in before the execution of the
+    ///     instruction.
+    /// </summary>
+    [Storable]
+    public int MinPointsInProgram { get; set; }
+
+    /// <summary>
     ///     This is the maximum size of an item on the CODE stack, expressed as a number of points.
     ///     A point is an instruction, a literal, or a pair of parentheses. Any instruction that would cause this limit to be
-    ///     exceeded
-    ///     should instead act as a NOOP, leaving all stacks in the states that they were in before the execution of the
+    ///     exceeded should instead act as a NOOP, leaving all stacks in the states that they were in before the execution of the
     ///     instruction.
     /// </summary>
@@ -155,4 +161,20 @@
     [Storable]
     public int MaxVectorLength { get; set; }
+
+
+    public void SetEnabledStacks(StackTypes types) {
+      // Disable all
+      EnabledExpressions.Clear();
+
+      // Enable those are required
+      foreach (StackTypes type in Enum.GetValues(types.GetType())) {
+        if (type == StackTypes.None) continue;
+
+        enabledStacks[type] = false;
+
+        if (types.HasFlag(type))
+          EnableStack(type, true);
+      }
+    }
 
     public void EnableExpressionOfStack(StackTypes types) {
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Constants/Environment.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Constants/Environment.cs	(revision 14897)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Constants/Environment.cs	(revision 14897)
@@ -0,0 +1,10 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Constants {
+  public static class PushEnvironment {
+    public const char VectorStartSymbol = '[';
+    public const char VectorEndSymbol = ']';
+    public const char VectorSeparatorSymbol = ' ';
+
+    public const char CharacterSymbol = '\'';
+    public const char StringSymbol = '\"';
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EqualsExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EqualsExpressions.cs	(revision 14875)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EqualsExpressions.cs	(revision 14897)
@@ -1,9 +1,8 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
   using System.Collections.Generic;
-
-  using HeuristicLab.Common;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
+  using Attributes;
+  using Common;
+  using Interpreter;
+  using Stack;
 
   /// <summary>
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PrintExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PrintExpressions.cs	(revision 14897)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PrintExpressions.cs	(revision 14897)
@@ -0,0 +1,127 @@
+﻿using System;
+
+namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
+  using System.Collections.Generic;
+  using System.Text;
+
+  using Attributes;
+
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Constants;
+
+  using Interpreter;
+  using Stack;
+
+  [PushExpression(StackTypes.Print, "PRINT.NEWLINE")]
+  public class PrintNewLineExpression : StatelessExpression {
+    public override bool Eval(IInternalPushInterpreter interpreter) {
+      interpreter.PrintStack.Push(Environment.NewLine);
+      return true;
+    }
+  }
+
+  public abstract class PrintExpression<T> : StatelessExpression {
+    protected bool Eval(IInternalPushInterpreter interpreter, IPushStack<T> stack) {
+      if (stack.IsEmpty)
+        return false;
+
+      var value = stack.Pop().ToString();
+      interpreter.PrintStack.Push(value);
+      return true;
+    }
+
+    protected bool EvalVector(IInternalPushInterpreter interpreter, IPushStack<List<T>> vectorStack) {
+      if (vectorStack.IsEmpty)
+        return false;
+
+      var sb = new StringBuilder();
+      var vector = vectorStack.Pop();
+
+      sb.Append(PushEnvironment.VectorStartSymbol);
+
+      if (vector.Count > 0) {
+        sb.Append(vector[0]);
+
+        for (var i = 1; i < vector.Count; i++) {
+          sb.Append(PushEnvironment.VectorSeparatorSymbol);
+          sb.Append(vector[i]);
+        }
+      }
+
+      sb.Append(PushEnvironment.VectorEndSymbol);
+
+      var value = sb.ToString();
+      interpreter.PrintStack.Push(value);
+      return true;
+    }
+  }
+
+  [PushExpression(StackTypes.Print, "PRINT.PRINTBOOLEAN", StackTypes.Boolean)]
+  public class BooleanPrintExpression : PrintExpression<bool> {
+    public override bool Eval(IInternalPushInterpreter interpreter) {
+      return Eval(interpreter, interpreter.BooleanStack);
+    }
+  }
+
+  [PushExpression(StackTypes.Print, "PRINT.PRINTCHAR", StackTypes.Char)]
+  public class CharPrintExpression : PrintExpression<char> {
+    public override bool Eval(IInternalPushInterpreter interpreter) {
+      return Eval(interpreter, interpreter.CharStack);
+    }
+  }
+
+  [PushExpression(StackTypes.Print, "PRINT.PRINTEXEC", StackTypes.Exec)]
+  public class ExecPrintExpression : PrintExpression<Expression> {
+    public override bool Eval(IInternalPushInterpreter interpreter) {
+      return Eval(interpreter, interpreter.ExecStack);
+    }
+  }
+
+  [PushExpression(StackTypes.Print, "PRINT.PRINTFLOAT", StackTypes.Float)]
+  public class FloatPrintExpression : PrintExpression<double> {
+    public override bool Eval(IInternalPushInterpreter interpreter) {
+      return Eval(interpreter, interpreter.FloatStack);
+    }
+  }
+
+  [PushExpression(StackTypes.Print, "PRINT.PRINTINTEGER", StackTypes.Integer)]
+  public class IntegerPrintExpression : PrintExpression<long> {
+    public override bool Eval(IInternalPushInterpreter interpreter) {
+      return Eval(interpreter, interpreter.IntegerStack);
+    }
+  }
+
+  [PushExpression(StackTypes.Print, "PRINT.PRINTSTRING", StackTypes.String)]
+  public class StringPrintExpression : PrintExpression<string> {
+    public override bool Eval(IInternalPushInterpreter interpreter) {
+      return Eval(interpreter, interpreter.StringStack);
+    }
+  }
+
+  [PushExpression(StackTypes.Print, "PRINT.PRINTINTEGERVECTOR", StackTypes.IntegerVector)]
+  public class IntegerVectorPrintExpression : PrintExpression<long> {
+    public override bool Eval(IInternalPushInterpreter interpreter) {
+      return EvalVector(interpreter, interpreter.IntegerVectorStack);
+    }
+  }
+
+  [PushExpression(StackTypes.Print, "PRINT.PRINTFLOATVECTOR", StackTypes.FloatVector)]
+  public class FloatVectorPrintExpression : PrintExpression<double> {
+    public override bool Eval(IInternalPushInterpreter interpreter) {
+      return EvalVector(interpreter, interpreter.FloatVectorStack);
+    }
+  }
+
+  [PushExpression(StackTypes.Print, "PRINT.PRINTSTRINGVECTOR", StackTypes.StringVector)]
+  public class StringVectorPrintExpression : PrintExpression<string> {
+    public override bool Eval(IInternalPushInterpreter interpreter) {
+      return EvalVector(interpreter, interpreter.StringVectorStack);
+    }
+  }
+
+  [PushExpression(StackTypes.Print, "PRINT.PRINTBOOLEANVECTOR", StackTypes.BooleanVector)]
+  public class BooleanVectorPrintExpression : PrintExpression<bool> {
+    public override bool Eval(IInternalPushInterpreter interpreter) {
+      return EvalVector(interpreter, interpreter.BooleanVectorStack);
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RandExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RandExpressions.cs	(revision 14875)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RandExpressions.cs	(revision 14897)
@@ -1,9 +1,7 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
   using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Generators;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Generators.CodeGenerator;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-  using HeuristicLab.Random;
 
   /// <summary>
@@ -16,8 +14,5 @@
         return false;
 
-      var name = interpreter.CustomExpressions.Count == 0 || interpreter.Random.NextDouble() < interpreter.Configuration.ErcOptions.NameErcOptions.NewNameProbability
-                   ? ErcUtils.GetName(interpreter.Configuration.ErcOptions.NameErcOptions, interpreter.Random)
-                   : interpreter.CustomExpressions.Keys.SampleRandom(interpreter.Random);
-
+      var name = interpreter.Configuration.ErcOptions.NameErcOptions.GetErcValue(interpreter.Random);
       interpreter.NameStack.Push(name);
       return true;
@@ -34,5 +29,5 @@
         return false;
 
-      var value = ErcUtils.GetInteger(interpreter.Configuration.ErcOptions.IntegerErcOptions, interpreter.Random);
+      var value = interpreter.Configuration.ErcOptions.IntegerErcOptions.GetErcValue(interpreter.Random);
       interpreter.IntegerStack.Push(value);
       return true;
@@ -49,5 +44,5 @@
         return false;
 
-      var value = ErcUtils.GetDouble(interpreter.Configuration.ErcOptions.FloatErcOptions, interpreter.Random);
+      var value = interpreter.Configuration.ErcOptions.FloatErcOptions.GetErcValue(interpreter.Random);
       interpreter.FloatStack.Push(value);
       return true;
@@ -64,5 +59,5 @@
         return false;
 
-      var value = ErcUtils.GetBoolean(interpreter.Configuration.ErcOptions.BooleanErcOptions, interpreter.Random);
+      var value = interpreter.Configuration.ErcOptions.BooleanErcOptions.GetErcValue(interpreter.Random);
       interpreter.BooleanStack.Push(value);
       return true;
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Generators/CodeGenerator/CodeGeneratorUtils.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Generators/CodeGenerator/CodeGeneratorUtils.cs	(revision 14875)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Generators/CodeGenerator/CodeGeneratorUtils.cs	(revision 14897)
@@ -3,9 +3,10 @@
 
 namespace HeuristicLab.Problems.ProgramSynthesis.Push.Generators.CodeGenerator {
+  using Core;
+  using Expressions;
 
-  using HeuristicLab.Core;
-  using HeuristicLab.Problems.ProgramSynthesis.Base.Erc.Interfaces;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
+  using HeuristicLab.Problems.ProgramSynthesis.Base.Erc;
+
+  using Stack;
 
   internal static class CodeGeneratorUtils {
@@ -19,5 +20,5 @@
 
       return index >= enabledExpressions.Count
-        ? customExpressions.ElementAt(index - (enabledExpressions.Count - 1)).Value
+        ? customExpressions.Values.ElementAt(index - enabledExpressions.Count)
         : CreateExpressionOrErc(index, random, enabledExpressions, ercOptions);
     }
@@ -55,4 +56,5 @@
     }
 
+    private static readonly Expression Noop = ExpressionTable.GetStatelessExpression<ExecNoopExpression>();
     /// <summary>
     /// Create a ErcExpression whereby the type of the expression conforms to the passed stack type.
@@ -65,41 +67,35 @@
       switch (type) {
         case StackTypes.Integer:
-          if (ercOptions.IntegerErcOptions == null || !ercOptions.IntegerErcOptions.IsEnabled)
-            return ExpressionTable.GetStatelessExpression<ExecNoopExpression>();
-
-          var intValue = ErcUtils.GetInteger(ercOptions.IntegerErcOptions, random);
-
-          return new IntegerPushExpression(intValue);
+          return ercOptions.IntegerErcOptions == null || !ercOptions.IntegerErcOptions.IsEnabled
+             ? Noop
+             : new IntegerPushExpression(ercOptions.IntegerErcOptions.GetErcValue(random));
 
         case StackTypes.Float:
-          if (ercOptions.FloatErcOptions == null || !ercOptions.FloatErcOptions.IsEnabled)
-            return ExpressionTable.GetStatelessExpression<ExecNoopExpression>();
-
-          var doubleValue = ErcUtils.GetDouble(ercOptions.FloatErcOptions, random);
-
-          return new FloatPushExpression(doubleValue);
+          return ercOptions.FloatErcOptions == null || !ercOptions.FloatErcOptions.IsEnabled
+            ? Noop
+            : new FloatPushExpression(ercOptions.FloatErcOptions.GetErcValue(random));
 
         case StackTypes.Boolean:
           return ercOptions.BooleanErcOptions == null || !ercOptions.BooleanErcOptions.IsEnabled
-            ? ExpressionTable.GetStatelessExpression<ExecNoopExpression>()
-            : new BooleanPushExpression(ErcUtils.GetBoolean(ercOptions.BooleanErcOptions, random));
+            ? Noop
+            : new BooleanPushExpression(ercOptions.BooleanErcOptions.GetErcValue(random));
 
         case StackTypes.Name:
           return ercOptions.NameErcOptions == null || !ercOptions.NameErcOptions.IsEnabled
-            ? ExpressionTable.GetStatelessExpression<ExecNoopExpression>()
-            : new NamePushExpression(ErcUtils.GetName(ercOptions.NameErcOptions, random));
+            ? Noop
+            : new NamePushExpression(ercOptions.NameErcOptions.GetErcValue(random));
 
         case StackTypes.String:
           return ercOptions.StringErcOptions == null || !ercOptions.StringErcOptions.IsEnabled
-            ? ExpressionTable.GetStatelessExpression<ExecNoopExpression>()
-            : new StringPushExpression(ErcUtils.GetString(ercOptions.StringErcOptions, random));
+            ? Noop
+            : new StringPushExpression(ercOptions.StringErcOptions.GetErcValue(random));
 
         case StackTypes.Char:
           return ercOptions.CharErcOptions == null || !ercOptions.CharErcOptions.IsEnabled
-            ? ExpressionTable.GetStatelessExpression<ExecNoopExpression>()
-            : new CharPushExpression(ErcUtils.GetChar(ercOptions.CharErcOptions, random));
+            ? Noop
+            : new CharPushExpression(ercOptions.CharErcOptions.GetErcValue(random));
 
         default:
-          return ExpressionTable.GetStatelessExpression<ExecNoopExpression>();
+          return Noop;
       }
     }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/IPushInterpreter.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/IPushInterpreter.cs	(revision 14875)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/IPushInterpreter.cs	(revision 14897)
@@ -24,7 +24,9 @@
     IPushStack<List<bool>> BooleanVectorStack { get; }
     IPushStack<List<string>> StringVectorStack { get; }
+    IPushStack<string> PrintStack { get; }
     IDictionary<string, Expression> CustomExpressions { get; }
     IReadOnlyPushConfiguration Configuration { get; }
     void Clear();
+    void Reset();
     void Run(string code, bool stepwise = false);
     void Run(Expression expression, bool stepwise = false);
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreter.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreter.cs	(revision 14875)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreter.cs	(revision 14897)
@@ -73,4 +73,8 @@
       };
 
+      PrintStack = new PushStack<string> {
+        IsEnabled = Configuration.EnabledStacks[StackTypes.Print]
+      };
+
       CustomExpressions = new Dictionary<string, Expression>();
       PoolContainer = poolContainer ?? new InterpreterPoolContainer();
@@ -155,4 +159,7 @@
     [PushStack(StackTypes.StringVector)]
     public IPushStack<List<string>> StringVectorStack { get; private set; }
+
+    [PushStack(StackTypes.Print)]
+    public IPushStack<string> PrintStack { get; private set; }
 
     public IDictionary<string, Expression> CustomExpressions { get; private set; }
